import { Component, OnInit, Input } from '@angular/core';
import { ITF14 } from './itf14';

@Component({
  selector: 'app-itf14-barcode',
  templateUrl: './itf14-barcode.component.html',
  styleUrls: ['./itf14-barcode.component.css']
})
export class Itf14BarcodeComponent implements OnInit {

  barcode: string;
  barcode_text: string;

  @Input() data: string="12345678";
  @Input() checkDigit: boolean=true;
  @Input() itfRectangle: boolean=false;

constructor() { 
}

ngOnInit() {
  var itf14=new ITF14(this.data,this.checkDigit,this.itfRectangle);
  this.barcode=itf14.encode();
  this.barcode_text=itf14.connectcode_human_readable_text;

}
}
