/*
 * ConnectCode
 *
 * Copyright (c) 2006-2019 ConnectCode Pte Ltd (https://www.barcoderesource.com)
 * All Rights Reserved.
 *
 * This source code is protected by International Copyright Laws. You are only allowed to modify
 * and include the source in your application if you have purchased a Distribution License.
 *
 * http://www.barcoderesource.com
 *
 */

import { LitElement, html } from 'lit-element';
import { encode, getText } from './js/connectcode-javascript-ext5'

class Ext5 extends LitElement {
  constructor() {
    super();
    this.input = '12345';
  }

  render() {
    return html`
    <style>
    @font-face {
      font-family: CCodeUPCEAN_S3_Trial;
      src: url("./fonts/ConnectCodeUPCEAN_S3_Trial.woff2") format("woff2");
    }      
    .EXT5 {width: 5in}
    .barcode_ext5 {font-weight: normal; font-style: normal; line-height:normal; font-family: 'CCodeUPCEAN_S3_Trial', sans-serif; font-size: 32px}
    .barcode_text_ext5 {font-weight: normal; font-style: normal; line-height:normal; font-family: sans-serif; font-size: 28px}

    </style>
    <div class='EXT5'>
      <center>	
        <div class='barcode_ext5'>${encode(this.input)}</div>	
        <div class='barcode_text_ext5'>${getText()}</div>	
      </center>
      </div>
`;
  }

  static get properties() {
    return {
      input: String,
      checkDigit: String
    }
  }
}

customElements.define('barcode-ext5', Ext5);
