/*
 * ConnectCode
 *
 * Copyright (c) 2006-2019 ConnectCode Pte Ltd (https://www.barcoderesource.com)
 * All Rights Reserved.
 *
 * This source code is protected by International Copyright Laws. You are only allowed to modify
 * and include the source in your application if you have purchased a Distribution License.
 *
 * http://www.barcoderesource.com
 *
 */

import { LitElement, html } from 'lit-element';
import { encode, getText } from './js/connectcode-javascript-gs1databar14'

class GS1Databar14 extends LitElement {
  constructor() {
    super();
    this.input = '12345678';
  }

  render() {
    return html`
    <style>
    @font-face {
      font-family: CCodeGS1D_S3_Trial;
      src: url("./fonts/ConnectCodeGS1D_S3_Trial.woff2") format("woff2");
    }      
    .GS1Databar14 {width: 5in}
    .barcode_gs1databar14 {font-weight: normal; font-style: normal; line-height:normal; font-family: 'CCodeGS1D_S3_Trial', sans-serif; font-size: 32px}
    .barcode_text_gs1databar14 {font-weight: normal; font-style: normal; line-height:normal; font-family: sans-serif; font-size: 18px}

    </style>
    <div class='GS1Databar14'>
      <center>	
        <div class='barcode_gs1databar14'>${encode(this.input,this.linkage)}</div>	
        <div class='barcode_text_gs1databar14'>${getText()}</div>	
      </center>
      </div>
`;
  }

  static get properties() {
    return {
      input: String,
      linkage: String
    }
  }
}

customElements.define('barcode-gs1databar14', GS1Databar14);
