/*
 * ConnectCode
 *
 * Copyright (c) 2006-2019 ConnectCode Pte Ltd (https://www.barcoderesource.com)
 * All Rights Reserved.
 *
 * This source code is protected by International Copyright Laws. You are only allowed to modify
 * and include the source in your application if you have purchased a Distribution License.
 *
 * http://www.barcoderesource.com
 *
 */

import { LitElement, html } from 'lit-element';
import { encode, getText } from './js/connectcode-javascript-industrial2of5'

// This element is *not* connected to the Redux store.
class Industrial2of5 extends LitElement {
  constructor() {
    super();
    this.input = '12345678';
  }

  render() {
    return html`
    <style>
    @font-face {
      font-family: CCodeIND2of5_S3_Trial;
      src: url("./fonts/ConnectCodeIND2of5_S3_Trial.woff2") format("woff2");
    }      
    .Industrial2of5 {width: 5in}
    .barcode_industrial2of5 {font-weight: normal; font-style: normal; line-height:normal; font-family: 'CCodeIND2of5_S3_Trial', sans-serif; font-size: 32px}
    .barcode_text_industrial2of5 {font-weight: normal; font-style: normal; line-height:normal; font-family: sans-serif; font-size: 28px}

    </style>
    <div class='Industrial2of5'>
      <center>	
        <div class='barcode_industrial2of5'>${encode(this.input,this.checkDigit)}</div>	
        <div class='barcode_text_industrial2of5'>${getText()}</div>	
      </center>
      </div>
`;
  }

  static get properties() {
    return {
      input: String,
      checkDigit: String
    }
  }
}

customElements.define('barcode-industrial2of5', Industrial2of5);
