/*
 * ConnectCode
 *
 * Copyright (c) 2006-2019 ConnectCode Pte Ltd (https://www.barcoderesource.com)
 * All Rights Reserved.
 *
 * This source code is protected by International Copyright Laws. You are only allowed to modify
 * and include the source in your application if you have purchased a Distribution License.
 *
 * http://www.barcoderesource.com
 *
 */

import { LitElement, html } from 'lit-element';
import { encode, getText } from './js/connectcode-javascript-uccean'

class UCCEAN extends LitElement {
  constructor() {
    super();
    this.input = '(10)12345678';
  }

  render() {
    return html`
    <style>
    @font-face {
      font-family: CCode128_S3_Trial;
      src: url("./fonts/ConnectCode128_S3_Trial.woff2") format("woff2");
    }      
    .UCCEAN {width: 5in}
    .barcode_uccean {font-weight: normal; font-style: normal; line-height:normal; font-family: 'CCode128_S3_Trial', sans-serif; font-size: 32px}
    .barcode_text_uccean {font-weight: normal; font-style: normal; line-height:normal; font-family: sans-serif; font-size: 28px}

    </style>
    <div class='UCCEAN'>
      <center>	
        <div class='barcode_uccean'>${encode(this.input,this.gs1Compliance)}</div>	
        <div class='barcode_text_uccean'>${getText()}</div>	
      </center>
      </div>
`;
  }

  static get properties() {
    return {
      input: String,
      gs1Compliance: String
    }
  }
}

customElements.define('barcode-uccean', UCCEAN);
